/* Ioannou Spiros
 * Tavernarakis Costas
 * Sat Nov 15 00:41:48 EET 1997
 * programm called by "getok" option of XTACACSD
 *
 * Features:
           - Validate user shell with ETCSHELLS file
	   - Implement connect time quotas
	   - Allow infinite time quotas for users
	     in MODEMGRP group
	   - Only tested under Sunos5.6 
	     
 */

#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <pwd.h>
#include <grp.h>
#include <limits.h>

#ifndef TIMEPERDAY
#define TIMEPERDAY 10800
#endif

#ifndef ETCSHELLS
#define ETCSHELLS "/etc/shells"
#endif

#ifndef MODEMGRP
#define MODEMGRP "modem"
#endif

long totsecs;
char * cmdh="/opt/tacacs/bin/taclast -tt ";
char * cmdt="| /bin/awk 'NR==4 {print $4}'";
char  cmd[256];
char buf[1024];

main(int argc, char *argv[]) {
    struct passwd * passwd_s, *coco;
    struct group * gp;
    gid_t       mygidset[NGROUPS_MAX]; /*change for sunos4*/

    int i,match;
    char wline[80];
    FILE *pwfd;
    FILE *cmdptr;

    if (argc<2) {
	    exit(0);
    }

    openlog("getok", LOG_PID, LOG_AUTH);

    if ((pwfd=fopen(ETCSHELLS,"r"))==0) {
	    syslog(LOG_NOTICE,"-421:cannot open /etc/shells");
	    exit(0);
    }


    passwd_s=(struct passwd*)malloc(sizeof(struct passwd));

    if (coco=getpwnam(argv[1]))
	    memcpy(passwd_s,coco,sizeof(struct passwd));
    else {
	    syslog(LOG_NOTICE,"-423:invalid user name:%s",argv[1]);
	    exit(0);
    }

    /*Check /etc/shells to validate shell*/

    match=0;

    while (fgets(wline,sizeof(wline),pwfd))  {
	    if  (strstr(wline,passwd_s->pw_shell)) match++;
    }

    if (!match) {
	    syslog(LOG_NOTICE,"-424:invalid user shell:%s for user %s",passwd_s->pw_shell,
		argv[1]);
	    /*Nasty user*/
	    exit(0);
    }
/*Shell validated*/

/*Check group to see if timecheck is needed*/

 match=0;
 if ((gp = getgrnam(MODEMGRP)) != NULL) {
	    for (i = 0;(i<NGROUPS_MAX) && gp->gr_mem[i]; ++i)
	        if (!strcmp(gp->gr_mem[i],argv[1])) {
                   match++;
		   break;
	 	}
 if (match)  exit(1);
 }


/*Not a member, or group "modem" does not exist,check times now.*/


    /*Update our totsecs(=seconds since last roll over) variable*/

	       strcpy(cmd,cmdh);
	       strcat(cmd,argv[1]);
	       strcat(cmd,cmdt);

               if ((cmdptr = popen(cmd, "r")) == NULL){
		 syslog(LOG_NOTICE,"-425:popen error");
		 exit(-4);
               }
		fgets(buf, 1024, cmdptr) ;
		pclose(cmdptr);
		
		totsecs=atol(buf);
/*	        (void) printf("totsecs:%ld\n", totsecs);*/


    /*His time is out*/
    if (TIMEPERDAY < (totsecs + 600)) exit (0);


    /*Ok, let him in */
    exit(1);
}
